// ***************************************************************************
// * ^Cg   : Ⴄ Java                                      *
// * o[W : Ver2.0                                                     *
// * 쌠     : Copyright (c) 2000                                         *
// *        :  ÕF                                                    *
// * Ж     : čύH[                                               *
// *        : Ⴄ Java Ver2.0                               *
// *              T[o (f[^Mj                                 *
// ***************************************************************************

// ***************************************************************************
// *                                                                         *
// *                             XV                                    *
// *                                                                         *
// * (C) Yoshihiko Hara    2000.06.22 ō쐬                               *
// *                                                                         *
// ***************************************************************************
package shinodas.netUra.server.msg;

import java.io.*;
import java.net.*;
import java.util.*;
import shinodas.netUra.data.uData;

public class URAServer extends Thread{
	ServerSocket ssok;

	public URAServer(int serverID){
		try{
			ssok = new ServerSocket(serverID);
		}catch(IOException e){
			System.err.println(e);
			System.exit(1);
		}
		this.start();
	}

	public void run(){

		// ʐM̗LmFAʐM薈ɒʐMp̃XbhNB
		boolean listening = true;
		while(listening){
			Socket csok = null;

			// ʐM̗LmFB
			try {
				csok = ssok.accept();
			}catch(IOException e){
				// ʐM肪Ȃꍇ͒ʐMp̃Xbh͋NA
				// ēxAʐM̗L̖₢킹sB
				continue;
			}

			// ʐM薈ɒʐMp̃XbhNB
			new generalServerSocketThread(csok).start();
		}

		// ʐMIƂȂꍇ́AT[o\Pbgjiʏ킱ւ́A
		// ͑JڂȂjB
		try{
			ssok.close();
		}catch(IOException e){
			;
		}
	}

	public static void main(String[] args){
		new URAServer(9999);
	}
}

class generalServerSocketThread extends Thread{
	Socket csok = null;

	public generalServerSocketThread(Socket socket){
		csok = socket;
	}

	public void run(){

		if(csok == null) return;
		
		try{
			ObjectInputStream in
				= new ObjectInputStream(csok.getInputStream());

			// ˗IuWFNg̎M
			uData uD = (uData)in.readObject();

			// ʂɂ鏈˗̐U蕪{
			switch(uD.JOB){
				case uD.AISYOU:
					uD = new aisyou(uD).getUD();
					break;
				case uD.SEIKAKU:
				case uD.ZAIUN:
				case uD.KENKOU:
				case uD.ISEI:
					uD = new personal(uD).getUD();
					break;
			}

			// ԐM̔s
			ObjectOutputStream out
				= new ObjectOutputStream(csok.getOutputStream());
			out.writeObject(uD);
			out.flush();

			// ؒf
			csok.close();

		}catch(Exception e){
			System.err.println(e);
			System.exit(1);
		}
    }
}
