// ***************************************************************************
// * ^Cg   : Ⴄ Java                                      *
// * o[W : Ver2.0                                                     *
// * 쌠     : Copyright (c) 2000                                         *
// *        :  ÕF                                                    *
// * Ж     : čύH[                                               *
// *        : Ⴄ Java Ver2.0                               *
// *              T[o (Zopʋ@\j                           *
// ***************************************************************************

// ***************************************************************************
// *                                                                         *
// *                             XV                                    *
// *                                                                         *
// * (C) Yoshihiko Hara    2000.06.22 ō쐬(ALMANAC2NXƗ)       *
// *                                                                         *
// ***************************************************************************
package shinodas.netUra.server.cal;

public class JDChg{

	// ***********************************************************************
	// *                                                                     *
	// *  ʕϐ                                                         *
	// *                                                                     *
	// ***********************************************************************

	/** ߂tij̔N̊̕i[ */
	public int JDC_yyyy;     // A.DN

	/** ߂tiǰ̊̕i[ */
	public int JDC_mm;       // A.D

	/** ߂tij̓̊̕i[ */
	public int JDC_dd;       // A.D

	/** ߂tij̎̊̕i[ */
	public double JDC_time;  // A.D

	/** ߂tij̊̕̕i[ */
	public double JDC_min;   // A.D

	/** ߂tij̕b̊̕i[ */
	public double JDC_sec;   // A.Db

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF JDChg                                                 *
	// *                                                                     *
	// *  @\      F RXgN^                                        *
	// *                                                                     *
	// *        F Ȃ                                                  *
	// *                                                                     *
	// *  o      F Ȃ                                                  *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.22    *
	// *                                                                     *
	// ***********************************************************************
	/**
		RXgN^B
	*/
	public JDChg(){
		;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF JDChg                                                 *
	// *                                                                     *
	// *  @\      F RXgN^                                        *
	// *               iDciEXʔNj`DciIjNɕϊ    *
	// *                                                                     *
	// *        F @ J.DN(double)                                      *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F Ȃ(void)Aʂ͋ʕϐɐݒ肷                *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.10.22    *
	// *                                                                     *
	// ***********************************************************************
	/**
		RXgN^BiDciEXʔNj`DciIjNɕϊB
		@param xjd  `DciIjNɕϊ悤ƂiDciEXʔNjB
		@param lon  iDciEXʔNj߂ꏊ̓oB
	*/
	public JDChg(double xjd,double lon){
		jd2ad(xjd,lon);
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF jd2ad                                                 *
	// *                                                                     *
	// *  @\      F iDciEXʔNj`DciIjNɕϊ    *
	// *                                                                     *
	// *        F @ J.DN(double)                                      *
	// *               A o(double)                                       *
	// *                                                                     *
	// *  o      F Ȃ(void)Aʂ͋ʕϐɐݒ肷                *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.12    *
	// *                                                                     *
	// ***********************************************************************
	/**
		iDciEXʔNj`DciIjNɕϊB
		@param xjd  `DciIjNɕϊ悤ƂiDciEXʔNjB
		@param lon  iDciEXʔNj߂ꏊ̓oB
	*/
	public void jd2ad(double xjd,       // J.DN
					  double lon){      // o

		double  ai;
		double  ak;
		double  b;
		double  c;
		double  d;
		double  e;
		double  e1;
		double  e2;
		double  e3;
		double  iy;
		double  m;
		double  xk;
		double  xn;
		double  xf;
		double  z;

		double  time;
		double  min;
		double  sec;
		double  tms;

   	// **********************
   	// * J.DA.Dɖ߂ *
   	// **********************
		xn   = xjd + 0.5 + (lon / 360.0);
		tms  = xn - (int)xn;
		tms  = tms * 24;
		time = (int)tms;
		tms  = tms - time;
		tms  = tms * 60;
		min  = (int)tms;
		tms  = tms - min;
		tms  = tms * 60;
		sec  = (int)tms;

		z  = (int)xn;
		xf = xn  - (int)xn;
		if(z > 2299161L){
			ak = (int)((z - 1867216.25) / 36524.3);
			ai = z + 1 + ak - (int)(ak / 4);
		}else{
			ai = z;
		}
		b  = ai + 1524.0;
		c  = (int)((b - 122.1) / 365.25);
		xk = (int)(365.25 * c);
		e1 = (b - xk) / 30.6001;
		e2 = (int)((b - xk) / 30.6001);
		if(e1>0){
			e = e2;
		}else{
			e3 = e1 - (double)e2;
			e3 = e3 * (-1);
			if(e3<0.5) e = e2;
			else       e = e2 -1;
		}
		d = b - xk - (int)(30.6001 * e) + xf;
		if(e < 13.5) m = e - 1;
		else         m = e - 13;
		if(m > 2.5) iy = c - 4716;
		else        iy = c - 4715;

		// ********************
		// * ԋpl̍쐬 *
		// ********************
		JDC_yyyy = (int)iy;
		JDC_mm   = (int)m;
		JDC_dd   = (int)d;
		JDC_time = (double)time;
		JDC_min  = (double)min;
		JDC_sec  = (double)sec;

		// ******************
		// * [N̒ *
		// ******************
		if(JDC_mm == 2 && JDC_dd == 29){
			if((JDC_yyyy % 100) == 0 && (JDC_yyyy % 400) != 0){
				JDC_mm = 3;
				JDC_dd = 1;
			}
		}

		return;
    }

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF bc2ad                                                 *
	// *                                                                     *
	// *  @\      F aDbiIOjN`DciIjNɕϊ        *
	// *                                                                     *
	// *        F B.CN(int)                                            *
	// *                                                                     *
	// *  o      F A.DN(int)                                            *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.02    *
	// *                                                                     *
	// ***********************************************************************
	/**
		aDbiIOjN`DciIjNɕϊB
		@param bc   aDbiIOjNB
		@return     `DciIjNB
	*/
    public int bc2ad(int bc){
        // IO̔NINɕς͈ȉ̒ʂ
        // IN = -( ION - 1 )
        // ex......IO5N = I -4N (  (5-1)  )
        return(-(bc-1)) ;
    }

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF ad2jd                                                 *
	// *                                                                     *
	// *  @\      F `DciIjNiDciEXʔNjɕϊ    *
	// *                                                                     *
	// *        F @ A.DN(int)                                         *
	// *               A A.D(int)                                         *
	// *               B A.D(int)                                         *
	// *               C A.D(double)                                      *
	// *               D A.D(double)                                      *
	// *               E A.Db(double)                                      *
	// *               F o(double)                                       *
	// *                                                                     *
	// *  o      F J.DN(double)                                         *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.02    *
	// *                                                                     *
	// ***********************************************************************
	/**
		`DciIjNiDciEXʔNjɕϊB
		@param yyyy   iDc߂悤ƂNi`DcjB
		@param mm     iDc߂悤Ƃ錎i`DcjB
		@param dd     iDc߂悤Ƃi`DcjB
		@param time   iDc߂悤Ƃ鎞i`DcjB
		@param min    iDc߂悤Ƃ镪i`DcjB
		@param sec    iDc߂悤Ƃbi`DcjB
		@param lon    iDc߂悤Ƃꏊ̓oB
		@return       iDciEXʔNjB
	*/
	public double ad2jd(int yyyy,     // A.DN
						int mm,       // A.D
						int dd,       // A.D
						double time,  // A.D
						double min,   // A.D
						double sec,   // A.Db
						double lon){  // o
		double  day;
		double  jd ;

		// ********************
		// * N̕␳s *
		// ********************
		// ϊPEQ̏ꍇ́Aȉ̕␳sB
		// ␳eEEENNO̔NɂւA12𑫂B
		if(mm<3){
			yyyy = yyyy -  1 ;
			mm   = mm   + 12 ;
		}

		// ******************************
		// * Ă̒Pʂ""ɓꂷ *
		// ******************************
		day = dd + time/24 + min/1440 + sec/86400L;

		// *******************
		// * J.D̎Zos *
		// *******************
		jd  = Math.floor(365.25 * yyyy) + Math.floor( 30.59 * (mm -2)) + day
			- lon/360 + 1721086.5;

		// **********************************************
		// * OSIԒ̉[Nɑ΂␳s *
		// **********************************************
		if(jd > 2299150L)
			jd = jd + Math.floor(yyyy / 400) - Math.floor(yyyy / 100) + 2;

		// ***************************************
		// * ZoJ.DԂlƂreturn *
		// ***************************************
		return jd;
	}

	// ***********************************************************************
	// *                                                                     *
	// *  \bhF jd2mjd                                                *
	// *                                                                     *
	// *  @\      F iDciEXʔNjlDiDciEXj  *
	// *               ϊ                                              *
	// *                                                                     *
	// *        F J.DN(double)                                         *
	// *                                                                     *
	// *  o      F M.J.DN(double)                                       *
	// *                                                                     *
	// *                                   (C) Yoshihiko Hara  1997.05.12    *
	// *                                                                     *
	// ***********************************************************************
	/**
		iDciEXʔNjlDiDciEXjɕϊB
		@param bc   iDciEXʔNjB
		@return     lDiDciEXjB
	*/
	public double jd2mjd(double jd){
		double  mjd;
		double  mjdcst = 2400000.5;
		mjd = jd - mjdcst;
		return mjd;
	}
}
